# Options

[![CI](https://github.com/purescript-contrib/purescript-options/workflows/CI/badge.svg?branch=main)](https://github.com/purescript-contrib/purescript-options/actions?query=workflow%3ACI+branch%3Amain)
[![Release](https://img.shields.io/github/release/purescript-contrib/purescript-options.svg)](https://github.com/purescript-contrib/purescript-options/releases)
[![Pursuit](https://pursuit.purescript.org/packages/purescript-options/badge)](https://pursuit.purescript.org/packages/purescript-options)
[![Maintainer: ethul](https://img.shields.io/badge/maintainer-ethul-teal.svg)](https://github.com/ethul)

Types and functions for dealing with JavaScript options objects.

## Installation

Install `options` with [Spago](https://github.com/purescript/spago):

```sh
spago install options
```

## Quick start

See the module documentation for [Options.purs](./src/Data/Options.purs).

## Documentation

`options` documentation is stored in a few places:

1. Module documentation is [published on Pursuit](https://pursuit.purescript.org/packages/purescript-options).
2. Written documentation is kept in [the docs directory](./docs).
3. Usage examples can be found in [the test suite](./test).

If you get stuck, there are several ways to get help:

- [Open an issue](https://github.com/purescript-contrib/purescript-options/issues) if you have encountered a bug or problem.
- [Search or start a thread on the PureScript Discourse](https://discourse.purescript.org) if you have general questions. You can also ask questions in the `#purescript` and `#purescript-beginners` channels on the [Functional Programming Slack](https://functionalprogramming.slack.com) ([invite link](https://fpchat-invite.herokuapp.com/)).

## Contributing

You can contribute to `options` in several ways:

1. If you encounter a problem or have a question, please [open an issue](https://github.com/purescript-contrib/purescript-options/issues). We'll do our best to work with you to resolve or answer it.

2. If you would like to contribute code, tests, or documentation, please [read the contributor guide](./CONTRIBUTING.md). It's a short, helpful introduction to contributing to this library, including development instructions.

3. If you have written a library, tutorial, guide, or other resource based on this package, please share it on the [PureScript Discourse](https://discourse.purescript.org)! Writing libraries and learning resources are a great way to help this library succeed.
